#include "Share.h"
#include "tlhelp32.h"
#include "hiStrMask.h"
#define TH32CS_SNAPNOHEAPS 0x40000000
#pragma comment(lib,"toolhelp.lib")

class THIEnumProcess:public TDebug
{
   private:
      bool Pkill;
      DWORD iden;
      string FWorkExt,s,fn;
    void Search(string &Dir);
    void OutFiles(string &Dir,string &Name);      
      
   public: 
    string _prop_Name;
    bool _prop_FullPath;
    THI_Event *_data_Name;
    THI_Event *_event_onEnum;
    THI_Event *_event_onEndEnum;
    THI_Event *_event_onFind;
    
    HI_WORK_LOC(THIEnumProcess,_work_doEnum)
   {
           bool lRes;       
             HANDLE lProcSnapshot=CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);
                   PROCESSENTRY32 procEntry;
                  if(lProcSnapshot!=INVALID_HANDLE_VALUE)
      {
                  memset(&procEntry,0,sizeof(PROCESSENTRY32));
               procEntry.dwSize=sizeof(PROCESSENTRY32);
                lRes=Process32First(lProcSnapshot,&procEntry);
             while(lRes)
      {  _hi_onEvent(_event_onEnum,(string)procEntry.szExeFile);
                         lRes=Process32Next(lProcSnapshot,&procEntry);}
        
        }
            CloseToolhelp32Snapshot(lProcSnapshot);
             _hi_onEvent(_event_onEndEnum);
      }
              
   HI_WORK_LOC(THIEnumProcess,_work_doFindName)
    
    {  
	  HANDLE proc;
     string Dr = L"\\";
     FWorkExt = L"*exe";
	 bool findPr=false ;
        TData qt;
       string nk;
        s = ReadString(_Data,_data_Name,_prop_Name);                                                                
      HANDLE prss = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);
               PROCESSENTRY32 pre;  
              if(prss!=INVALID_HANDLE_VALUE)         
               memset(&pre,0,sizeof(pre));
               pre.dwSize=sizeof(pre);
              if (Process32First(prss,&pre))                   //  
                 nk = pre.szExeFile;
              do{                                          //     
                 if(string(pre.szExeFile)==s)
           {   findPr=true;
          
               proc = OpenProcess(0,FALSE,pre.th32ProcessID);
                iden=pre.th32ProcessID;
                 if (Pkill&&proc)                          // 
		    { TerminateProcess(proc,0);
		     CloseHandle(proc); 
             Pkill=false;} 
		       }
		       }
		       while (Process32Next(prss,&pre));
                   if(nk==s)                             
                     findPr=true;
		       _hi_onEvent(_event_onFind,(int)findPr);
		              if(findPr&&_prop_FullPath)
		                {fn=L" "; Search(Dr);}
                  if(Pkill&&Process32First(prss,&pre))         //   
                  { 
                    proc = OpenProcess(0,FALSE,pre.th32ProcessID);
                   TerminateProcess(proc,0);
		            CloseHandle(proc); } 
               CloseToolhelp32Snapshot(prss);
              	     
  }  
    
   HI_WORK_LOC(THIEnumProcess,_work_doKill)
   { 
          Pkill = true;
          TData qt;
       _work_doFindName(qt,0); 
   } 
     
  HI_WORK_LOC(THIEnumProcess,_var_CurrentID) 
         { CreateData(_Data,(int)iden); }
          
  HI_WORK_LOC(THIEnumProcess,_var_FullPath)
         {CreateData(_Data,(string)fn);
          fn=L""; }        
                  
              
};

//#############################################################################

#define faReadOnly   0x00000001
#define faHidden     0x00000002
#define faSysFile    0x00000004
#define faVolumeID   0x00000008
#define faDirectory  0x00000010
#define faArchive    0x00000020
#define faAnyFile    0x0000003F

typedef struct
{    int Attr;
    string Name;
    int ExcludeAttr;
    HANDLE FindHandle;
    WIN32_FIND_DATA FindData;
}TSearchR;

void THIEnumProcess::OutFiles(string &Dir,string &Name)
{    Name.Lower(); s.Lower();
     if( Name==s )
     fn =Dir + Name;
}

void FindClose(TSearchR &F)
{
  if( F.FindHandle != INVALID_HANDLE_VALUE )
    FindClose(F.FindHandle);
}

int FindMatchingFile(TSearchR &F)
{
    FILETIME LocalFileTime;

    while( F.FindData.dwFileAttributes & F.ExcludeAttr )
     if( !FindNextFile(F.FindHandle, &F.FindData) )
       return GetLastError();
    FileTimeToLocalFileTime(&F.FindData.ftLastWriteTime, &LocalFileTime);
    F.Attr = F.FindData.dwFileAttributes;
    F.Name = F.FindData.cFileName;

    return 0;
}

#define faSpecial faHidden|faSysFile|faVolumeID|faDirectory

int FindFirst(string &Path,int Attr,TSearchR &F)
{
  F.ExcludeAttr = !(Attr & faSpecial);
  F.FindHandle = FindFirstFile(PChar(Path), &F.FindData);
  if( F.FindHandle != INVALID_HANDLE_VALUE )
    return FindMatchingFile(F);
  else  return GetLastError();
}

int FindNext(TSearchR &F)
{
  if( FindNextFile(F.FindHandle, &F.FindData) )
    return FindMatchingFile(F);
  else return GetLastError();
}

void THIEnumProcess::Search(string &Dir)
{
  TSearchR SRec;

  DWORD n = FindFirst(Dir + _his("*.*"),faAnyFile,SRec);
  while ( n == 0 )
  {
     if( SRec.Name[0] != _his('.') )
      if( SRec.Attr & faDirectory )
      {
        Search(Dir + SRec.Name + _his("\\"));
      }
      else if( StrCmp(SRec.Name,FWorkExt) )
      {
        OutFiles(Dir,SRec.Name);
      }
     n = FindNext(SRec);
  }
  FindClose(SRec);
}         
           
             
             
             